;;; This file is part of nanolisp, a very small Lisp system.

;;; Copyright (C) 2007  Luca Saiu

;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;; This procedure recursively calls itself an infinite number of
;;; times:
(define p
  (lambda (n)
    (display n)
    (newline)
    (p (+ n 1))))

;;; We call p, and a non-tail-recursive implementation should fail
;;; after a while, by overflowing the stack:
(p 0)
